"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncQueue = void 0;
var tslib_1 = require("tslib");
var DeferredPromise_1 = require("./promise/DeferredPromise");
var AsyncQueue = (function () {
    function AsyncQueue(fifo) {
        if (fifo === void 0) { fifo = true; }
        this.fifo = fifo;
        this._running = false;
        this._queue = [];
        this._promise = null;
    }
    AsyncQueue.prototype.add = function (job) {
        this._queue.push(job);
        this.run();
    };
    AsyncQueue.prototype.remove = function (job) {
        var _queue = this._queue;
        var i = _queue.indexOf(job);
        if (i >= 0) {
            _queue.splice(i, 1);
            return i;
        }
        return i;
    };
    AsyncQueue.prototype.run = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            var count, _queue, job;
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        count = 0;
                        if (!!this._running) return [3, 4];
                        this._running = true;
                        _queue = this._queue;
                        _a.label = 1;
                    case 1:
                        if (!(_queue.length > 0)) return [3, 3];
                        job = this.fifo ? _queue.shift() : _queue.pop();
                        return [4, job()];
                    case 2:
                        _a.sent();
                        count += 1;
                        return [3, 1];
                    case 3:
                        this._running = false;
                        if (this._promise) {
                            this._promise.resolve();
                            this._promise = null;
                        }
                        _a.label = 4;
                    case 4: return [2, count];
                }
            });
        });
    };
    AsyncQueue.prototype.running = function () {
        return this._running;
    };
    AsyncQueue.prototype.count = function () {
        return this._queue.length;
    };
    AsyncQueue.prototype.wait = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (this._running) {
                    if (!this._promise) {
                        this._promise = new DeferredPromise_1.DeferredPromise();
                    }
                    return [2, this._promise.promise];
                }
                return [2];
            });
        });
    };
    return AsyncQueue;
}());
exports.AsyncQueue = AsyncQueue;
//# sourceMappingURL=AsyncQueue.js.map