/// <reference types="node" />
export interface ISimpleCacheOptions<Value> {
    ttl?: number;
    maxSize?: number;
    initialStore?: IStore<Value>;
    initialKeys?: string[];
}
export interface IStore<Value> {
    [key: string]: Value;
}
export declare class SimpleCache<Value> {
    ttl?: number;
    maxSize?: number;
    ttlIds: IStore<NodeJS.Timeout>;
    protected store: IStore<Value>;
    protected _keys: string[];
    constructor(opts?: ISimpleCacheOptions<Value>);
    get size(): number;
    get(key: string): Value | undefined;
    has(key: string): boolean;
    set(key: string, value: Value, opts?: {
        ttl?: number;
    }): void;
    delete(key: string): boolean;
    clear(): void;
    forEach(fn: (value: Value, key: string) => void): void;
    getKeys(): string[];
    getValues(): Value[];
}
//# sourceMappingURL=SimpleCache.d.ts.map