"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateRunner = void 0;
var tslib_1 = require("tslib");
var DeferredPromise_1 = require("./promise/DeferredPromise");
var UpdateRunner = (function () {
    function UpdateRunner(job) {
        this.job = job;
        this._running = false;
        this._queued = false;
        this._promise = null;
    }
    UpdateRunner.prototype.queue = function () {
        if (this._running) {
            this._queued = true;
        }
        else {
            this.run();
        }
    };
    UpdateRunner.prototype.queued = function () {
        return this._queued;
    };
    UpdateRunner.prototype.running = function () {
        return this._running;
    };
    UpdateRunner.prototype.wait = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                if (this._running) {
                    if (!this._promise) {
                        this._promise = new DeferredPromise_1.DeferredPromise();
                    }
                    return [2, this._promise.promise];
                }
                return [2];
            });
        });
    };
    UpdateRunner.prototype.run = function () {
        return tslib_1.__awaiter(this, void 0, void 0, function () {
            return tslib_1.__generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this._queued = false;
                        this._running = true;
                        return [4, this.job()];
                    case 1:
                        _a.sent();
                        this._running = false;
                        if (this._queued) {
                            this.run();
                        }
                        else if (this._promise) {
                            this._promise.resolve();
                            this._promise = null;
                        }
                        return [2];
                }
            });
        });
    };
    return UpdateRunner;
}());
exports.UpdateRunner = UpdateRunner;
//# sourceMappingURL=UpdateRunner.js.map