"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.diff = void 0;
var countByIndex_1 = require("./countByIndex");
var unique_1 = require("./unique");
exports.diff = function (a, b, toKey, uniq) {
    if (uniq === void 0) { uniq = true; }
    var alen = a.length;
    var blen = b.length;
    if (!alen) {
        return [];
    }
    if (!blen) {
        return uniq ? unique_1.unique(a, toKey == null ? undefined : toKey) : a.slice();
    }
    var out = [];
    var bmap = countByIndex_1.countByIndex(b, toKey);
    var toKeyT = typeof toKey;
    if (uniq) {
        switch (toKeyT) {
            case 'function':
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = toKey(ai, i, a);
                    if (!(bmap[k] > 0)) {
                        bmap[k] = 1;
                        out.push(ai);
                    }
                }
                break;
            case 'string':
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = ai[toKey];
                    if (!(bmap[k] > 0)) {
                        bmap[k] = 1;
                        out.push(ai);
                    }
                }
                break;
            default:
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = ai;
                    if (!(bmap[k] > 0)) {
                        bmap[k] = 1;
                        out.push(ai);
                    }
                }
                break;
        }
    }
    else {
        switch (toKeyT) {
            case 'function':
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = toKey(ai, i, a);
                    if (bmap[k] > 0) {
                        bmap[k] -= 1;
                    }
                    else {
                        bmap[k] = -1;
                        out.push(ai);
                    }
                }
                break;
            case 'string':
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = ai[toKey];
                    if (bmap[k] > 0) {
                        bmap[k] -= 1;
                    }
                    else {
                        bmap[k] = -1;
                        out.push(ai);
                    }
                }
                break;
            default:
                for (var i = 0; i < alen; i += 1) {
                    var ai = a[i];
                    var k = ai;
                    if (bmap[k] > 0) {
                        bmap[k] -= 1;
                    }
                    else {
                        bmap[k] = -1;
                        out.push(ai);
                    }
                }
                break;
        }
    }
    return out;
};
//# sourceMappingURL=diff.js.map