"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniqueWithIndexes = void 0;
exports.uniqueWithIndexes = function (list, toKey) {
    var len = list.length;
    var indexes = [];
    if (!len) {
        return { list: [], indexes: indexes };
    }
    var keyToIndex = {};
    var ulist;
    var index = 0;
    switch (typeof toKey) {
        case 'function':
            ulist = list.filter(function (x, i) {
                var k = toKey(x, i, list);
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
        case 'string':
            ulist = list.filter(function (x, i) {
                var k = x[toKey];
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
        default:
            ulist = list.filter(function (x, i) {
                var k = String(x);
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
    }
    return { list: ulist, indexes: indexes };
};
//# sourceMappingURL=uniqueWithIndexes.js.map