"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDateNumbersInTimeZone = void 0;
var dateRegex = /^(\d+)\/(\d+)\/(\d+),\s*(\d+):(\d+):(\d+)\s*(\w+)$/;
exports.getDateNumbersInTimeZone = function (d, timeZone) {
    var dateStr = d.toLocaleString('en-US', { timeZone: timeZone });
    var match = dateStr.match(dateRegex);
    if (match) {
        try {
            var month0 = parseInt(match[1], 10) - 1;
            var date = parseInt(match[2], 10);
            var year = parseInt(match[3], 10);
            var hours = parseInt(match[4], 10) + (match[7] === 'PM' ? 12 : 0);
            var minutes = parseInt(match[5], 10);
            var seconds = parseInt(match[6], 10);
            return { month0: month0, date: date, year: year, hours: hours, minutes: minutes, seconds: seconds };
        }
        catch (e) {
        }
    }
    return null;
};
//# sourceMappingURL=getDateNumbersInTimeZone.js.map