"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.equal = exports.equalObjects = void 0;
var is_1 = require("../is");
var getKeys_1 = require("../object/getKeys");
var hasOwnProp_1 = require("../object/hasOwnProp");
exports.equalObjects = function (a, b, opts) {
    if (a === b) {
        return true;
    }
    var _a = opts.testKeys, testKeys = _a === void 0 ? true : _a, keys = opts.keys, skipKeys = opts.skipKeys, _b = opts.allowSubset, allowSubset = _b === void 0 ? false : _b;
    var skip = {};
    if (skipKeys) {
        var len = skipKeys.length;
        for (var i = 0; i < len; i += 1) {
            skip[skipKeys[i]] = 1;
        }
    }
    if (keys) {
        var len = keys.length;
        if (testKeys) {
            for (var i = 0; i < len; i += 1) {
                var k = keys[i];
                if (skip[k] !== 1) {
                    skip[k] = 1;
                    var hasKey = hasOwnProp_1.hasOwnProp(a, k);
                    if (hasKey !== hasOwnProp_1.hasOwnProp(b, k) ||
                        (hasKey && !exports.equal(a[k], b[k], opts))) {
                        return false;
                    }
                }
            }
        }
        else {
            for (var i = 0; i < len; i += 1) {
                var k = keys[i];
                if (skip[k] !== 1) {
                    skip[k] = 1;
                    if (!exports.equal(a[k], b[k], opts)) {
                        return false;
                    }
                }
            }
        }
        return true;
    }
    var keysA = getKeys_1.getKeys(a);
    var keysB = getKeys_1.getKeys(b);
    var lenA = keysA.length;
    var lenB = keysB.length;
    if (testKeys && !allowSubset) {
        if (!allowSubset && !skipKeys && lenA !== lenB) {
            return false;
        }
        for (var i = 0; i < lenA; i += 1) {
            var k = keysA[i];
            if (skip[k] !== 1) {
                skip[k] = 1;
                if (!hasOwnProp_1.hasOwnProp(b, k) || !exports.equal(a[k], b[k], opts)) {
                    return false;
                }
            }
        }
        if (!allowSubset) {
            for (var i = 0; i < lenB; i += 1) {
                var k = keysB[i];
                if (skip[k] !== 1) {
                    skip[k] = 1;
                    if (!hasOwnProp_1.hasOwnProp(a, k) || !exports.equal(a[k], b[k], opts)) {
                        return false;
                    }
                }
            }
        }
    }
    else {
        for (var i = 0; i < lenA; i += 1) {
            var k = keysA[i];
            if (skip[k] !== 1) {
                skip[k] = 1;
                if (!exports.equal(a[k], b[k], opts)) {
                    return false;
                }
            }
        }
        if (!allowSubset) {
            for (var i = 0; i < lenB; i += 1) {
                var k = keysB[i];
                if (skip[k] !== 1) {
                    skip[k] = 1;
                    if (!exports.equal(a[k], b[k], opts)) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
};
exports.equal = function (a, b, opts) {
    if (a === b || (a !== a && b !== b)) {
        return true;
    }
    var normalize = opts.normalize, equalValues = opts.equalValues;
    if (normalize) {
        a = normalize(a);
        b = normalize(b);
        if (a === b || (a !== a && b !== b)) {
            return true;
        }
    }
    if (equalValues && equalValues(a, b, opts)) {
        return true;
    }
    if (!is_1.isObject(a) || !is_1.isObject(b)) {
        return false;
    }
    if (Array.isArray(a) !== Array.isArray(b)) {
        return false;
    }
    return exports.equalObjects(a, b, opts);
};
//# sourceMappingURL=equal.js.map