"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shallowEqualObjects = void 0;
var getKeys_1 = require("../object/getKeys");
var hasOwnProp_1 = require("../object/hasOwnProp");
var shallowEqualValues_1 = require("./shallowEqualValues");
exports.shallowEqualObjects = function (a, b, opts) {
    if (a === b) {
        return true;
    }
    var _a = opts.testKeys, testKeys = _a === void 0 ? true : _a, keys = opts.keys, skipKeys = opts.skipKeys;
    var skip = {};
    if (skipKeys) {
        var len = skipKeys.length;
        for (var i = 0; i < len; i += 1) {
            skip[skipKeys[i]] = 1;
        }
    }
    if (keys) {
        var len = keys.length;
        for (var i = 0; i < len; i += 1) {
            var k = keys[i];
            if (skip[k] !== 1) {
                skip[k] = 1;
                if (testKeys) {
                    var hasKey = hasOwnProp_1.hasOwnProp(a, k);
                    if (hasKey !== hasOwnProp_1.hasOwnProp(b, k)) {
                        return false;
                    }
                    if (!hasKey) {
                        continue;
                    }
                }
                if (!shallowEqualValues_1.shallowEqualValues(a[k], b[k], opts)) {
                    return false;
                }
            }
        }
        return true;
    }
    var keysA = getKeys_1.getKeys(a);
    var lenA = keysA.length;
    var keysB = getKeys_1.getKeys(b);
    var lenB = keysB.length;
    if (testKeys && !skipKeys && lenA !== lenB) {
        return false;
    }
    for (var i = 0; i < lenA; i += 1) {
        var k = keysA[i];
        if (skip[k] !== 1) {
            skip[k] = 1;
            if ((testKeys && !hasOwnProp_1.hasOwnProp(b, k)) ||
                !shallowEqualValues_1.shallowEqualValues(a[k], b[k], opts)) {
                return false;
            }
        }
    }
    for (var i = 0; i < lenB; i += 1) {
        var k = keysB[i];
        if (skip[k] !== 1) {
            skip[k] = 1;
            if ((testKeys && !hasOwnProp_1.hasOwnProp(a, k)) ||
                !shallowEqualValues_1.shallowEqualValues(a[k], b[k], opts)) {
                return false;
            }
        }
    }
    return true;
};
//# sourceMappingURL=shallowEqualObjects.js.map