"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoize = void 0;
exports.memoize = function (fn) {
    var prevArgs = null;
    var prevReturn = null;
    return function memoizedFn() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var changed = false;
        if (prevArgs) {
            var len = args.length;
            for (var i = 0; i < len; i += 1) {
                if (args[i] !== prevArgs[i]) {
                    changed = true;
                    break;
                }
            }
        }
        else {
            changed = true;
        }
        if (changed) {
            prevArgs = args;
            prevReturn = fn.apply(this, args);
            return prevReturn;
        }
        return prevReturn;
    };
};
//# sourceMappingURL=memoize.js.map