"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoizeArg = void 0;
exports.memoizeArg = function (fn) {
    var called = false;
    var prevArg;
    var prevReturn;
    return function memoizedFn(arg) {
        if (called && arg === prevArg) {
            return prevReturn;
        }
        called = true;
        prevArg = arg;
        prevReturn = fn.call(this, arg);
        return prevReturn;
    };
};
//# sourceMappingURL=memoizeArg.js.map