"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoizeCompose = void 0;
var memoize_1 = require("./memoize");
var memoizeArg_1 = require("./memoizeArg");
exports.memoizeCompose = function (argFns, fn) {
    var len = argFns.length;
    if (len > 1) {
        var memoized1_1 = memoize_1.memoize(fn);
        return function memoizedFn() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var prevArgs = [];
            for (var i = 0; i < len; i += 1) {
                prevArgs.push(argFns[i].apply(this, args));
            }
            return memoized1_1.apply(this, prevArgs);
        };
    }
    var argFn = argFns[0];
    var memoized2 = memoizeArg_1.memoizeArg(fn);
    return function memoizedFn(arg) {
        return memoized2.call(this, argFn(arg));
    };
};
//# sourceMappingURL=memoizeCompose.js.map