"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepMapObjectWithoutEmpty = exports.deepMapArrayWithoutEmpty = void 0;
var is_1 = require("../is");
var getKeys_1 = require("../object/getKeys");
exports.deepMapArrayWithoutEmpty = function (arr, fn) {
    var copy = [];
    var len = arr.length;
    for (var i = 0; i < len; i += 1) {
        var value = arr[i];
        var newValue = void 0;
        if (is_1.isObject(value)) {
            if (Array.isArray(value)) {
                newValue = exports.deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = exports.deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, i, arr);
        }
        if (newValue != null && newValue === newValue) {
            copy.push(newValue);
        }
    }
    return copy.length ? copy : null;
};
exports.deepMapObjectWithoutEmpty = function (obj, fn) {
    var copy = {};
    var keys = getKeys_1.getKeys(obj);
    var len = keys.length;
    var nonEmpty = false;
    for (var i = 0; i < len; i += 1) {
        var key = keys[i];
        var value = obj[key];
        var newValue = void 0;
        if (is_1.isObject(value)) {
            if (Array.isArray(value)) {
                newValue = exports.deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = exports.deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, key, obj);
        }
        if (newValue != null && newValue === newValue) {
            nonEmpty = true;
            copy[key] = newValue;
        }
    }
    return nonEmpty ? copy : null;
};
//# sourceMappingURL=deepMap.js.map