"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapStruct = void 0;
var getKeys_1 = require("../object/getKeys");
exports.mapStruct = function (obj, fnMap) {
    var copy = {};
    var keys = getKeys_1.getKeys(obj);
    var len = keys.length;
    var nonEmpty = false;
    for (var i = 0; i < len; i += 1) {
        var key = keys[i];
        var fn = fnMap[key];
        if (fn) {
            var value = fn(obj[key], key, obj);
            if (value !== undefined && value === value) {
                nonEmpty = true;
                copy[key] = value;
            }
        }
    }
    return nonEmpty ? copy : undefined;
};
//# sourceMappingURL=mapStruct.js.map