"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.copy = void 0;
var getKeys_1 = require("./getKeys");
var hasOwnProp_1 = require("./hasOwnProp");
exports.copy = function (to, from, keys, own) {
    if (own === void 0) { own = true; }
    var out = to;
    if (keys) {
        var len = keys.length;
        if (own) {
            if (from.hasOwnProperty) {
                for (var i = 0; i < len; i += 1) {
                    var key = keys[i];
                    if (from.hasOwnProperty(key)) {
                        out[key] = from[key];
                    }
                }
            }
            else {
                for (var i = 0; i < len; i += 1) {
                    var key = keys[i];
                    if (hasOwnProp_1.hasOwnProperty.call(from, key)) {
                        out[key] = from[key];
                    }
                }
            }
        }
        else {
            for (var i = 0; i < len; i += 1) {
                var key = keys[i];
                if (key in from) {
                    out[key] = from[key];
                }
            }
        }
    }
    else {
        var fkeys = getKeys_1.getKeys(from);
        var len = fkeys.length;
        for (var i = 0; i < len; i += 1) {
            var key = fkeys[i];
            out[key] = from[key];
        }
    }
    return out;
};
//# sourceMappingURL=copy.js.map