"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepSortedCopy = void 0;
var getKeys_1 = require("./getKeys");
exports.deepSortedCopy = function (obj) {
    if (obj == null || typeof obj !== 'object') {
        return obj;
    }
    if (Array.isArray(obj)) {
        return obj.map(exports.deepSortedCopy);
    }
    var constructor = obj.constructor;
    if (constructor != null && constructor !== Object) {
        return obj;
    }
    var keys = getKeys_1.getKeys(obj);
    var len = keys.length;
    var dest = {};
    if (len) {
        keys = keys.sort();
        for (var i = 0; i < len; i += 1) {
            var key = keys[i];
            dest[key] = exports.deepSortedCopy(obj[key]);
        }
    }
    return dest;
};
//# sourceMappingURL=deepSortedCopy.js.map