"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.immutableSetter = void 0;
var tslib_1 = require("tslib");
var getter_1 = require("./getter");
exports.immutableSetter = function (path, cloneObject) {
    var keys = path.split('.');
    var lastIndex = keys.length - 1;
    var getValue = getter_1.getter(path);
    if (cloneObject) {
        return function (obj, value) {
            if (getValue(obj) === value) {
                return obj;
            }
            var newObj = tslib_1.__assign({}, obj);
            var scope = newObj;
            var i = 0;
            var curPath = [];
            for (; i < lastIndex; i += 1) {
                var key = keys[i];
                curPath.push(key);
                scope = scope[key] = cloneObject(scope[key], key, curPath, scope);
            }
            scope[keys[i]] = value;
            return newObj;
        };
    }
    return function (obj, value) {
        if (getValue(obj) === value) {
            return obj;
        }
        var newObj = tslib_1.__assign({}, obj);
        var scope = newObj;
        var i = 0;
        for (; i < lastIndex; i += 1) {
            var key = keys[i];
            scope = scope[key] = tslib_1.__assign({}, scope[key]);
        }
        scope[keys[i]] = value;
        return newObj;
    };
};
//# sourceMappingURL=immutableSetter.js.map