"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapKeys = void 0;
var getKeys_1 = require("./getKeys");
var hasOwnProp_1 = require("./hasOwnProp");
exports.mapKeys = function (obj, keyMappings, dest, own) {
    if (dest === void 0) { dest = {}; }
    if (own === void 0) { own = true; }
    var out = dest;
    var keys = getKeys_1.getKeys(keyMappings);
    var len = keys.length;
    if (own) {
        if (obj.hasOwnProperty) {
            for (var i = 0; i < len; i += 1) {
                var key = keys[i];
                if (obj.hasOwnProperty(key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
        else {
            for (var i = 0; i < len; i += 1) {
                var key = keys[i];
                if (hasOwnProp_1.hasOwnProperty.call(obj, key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
    }
    else {
        for (var i = 0; i < len; i += 1) {
            var key = keys[i];
            if (key in obj) {
                out[keyMappings[key]] = obj[key];
            }
        }
    }
    return out;
};
//# sourceMappingURL=mapKeys.js.map