"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setter = void 0;
exports.setter = function (path, createObject) {
    var keys = path.split('.');
    var lastIndex = keys.length - 1;
    if (createObject) {
        return function (obj, value) {
            var scope = obj;
            var i = 0;
            var curPath = [];
            for (; i < lastIndex; i += 1) {
                var key = keys[i];
                curPath.push(key);
                scope = scope[key] || (scope[key] = createObject(key, curPath, scope));
            }
            scope[keys[i]] = value;
            return obj;
        };
    }
    return function (obj, value) {
        var scope = obj;
        var i = 0;
        for (; i < lastIndex; i += 1) {
            var key = keys[i];
            scope = scope[key] || (scope[key] = {});
        }
        scope[keys[i]] = value;
        return obj;
    };
};
//# sourceMappingURL=setter.js.map