"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createBatcher = void 0;
exports.createBatcher = function (batch, delay) {
    if (delay === void 0) { delay = 0; }
    var argsQueue = [];
    var promise = null;
    var queueAndWait = function (args) {
        argsQueue.push(args);
        if (!promise) {
            promise = new Promise(function (resolve, reject) {
                setTimeout(function () {
                    var argsList = argsQueue;
                    argsQueue = [];
                    promise = null;
                    try {
                        batch(argsList).then(resolve, reject);
                    }
                    catch (e) {
                        reject(e);
                    }
                }, delay);
            });
        }
        return promise;
    };
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var index = argsQueue.length;
        return queueAndWait(args).then(function (res) { return res[index]; }, function (e) {
            if (Array.isArray(e)) {
                throw e[index];
            }
            throw e;
        });
    };
};
//# sourceMappingURL=createBatcher.js.map