"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toResult = void 0;
var dataToResult = function (data) { return ({
    data: data,
    error: null,
    resolved: true,
}); };
var errorToResult = function (error) { return ({
    data: null,
    error: error,
    resolved: false,
}); };
exports.toResult = function (x) {
    if (x != null) {
        if (typeof x.then === 'function') {
            return x.then(dataToResult, errorToResult);
        }
        if (x instanceof Error) {
            return errorToResult(x);
        }
    }
    return dataToResult(x);
};
//# sourceMappingURL=toResult.js.map