"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withTimeout = void 0;
exports.withTimeout = function (promise, timeout) {
    return new Promise(function (resolve, reject) {
        setTimeout(function () { return reject(new Error('timeout')); }, timeout);
        try {
            if (typeof promise === 'function') {
                promise().then(resolve, reject);
            }
            else {
                promise.then(resolve, reject);
            }
        }
        catch (e) {
            reject(e);
        }
    });
};
//# sourceMappingURL=withTimeout.js.map