"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inheritProps = void 0;
var hasOwnProp_1 = require("../object/hasOwnProp");
var inheritProp_1 = require("./inheritProp");
exports.inheritProps = function (to, from, excludeKeys) {
    var fromKeys = Object.getOwnPropertyNames(from);
    var len = fromKeys.length;
    if (excludeKeys) {
        for (var i = 0; i < len; i += 1) {
            var key = fromKeys[i];
            if (excludeKeys[key] !== 1 && !hasOwnProp_1.hasOwnProp(to, key)) {
                inheritProp_1.inheritProp(to, from, key);
            }
        }
    }
    else {
        for (var i = 0; i < len; i += 1) {
            var key = fromKeys[i];
            if (!hasOwnProp_1.hasOwnProp(to, key)) {
                inheritProp_1.inheritProp(to, from, key);
            }
        }
    }
    return to;
};
//# sourceMappingURL=inheritProps.js.map