"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseFileUrl = void 0;
exports.parseFileUrl = function (path) {
    var p = path || '';
    var lastSlash = p.lastIndexOf('/');
    var pathname = lastSlash >= 0 ? p.substring(0, lastSlash + 1) : '';
    var base = lastSlash >= 0 ? p.substring(lastSlash + 1) : p;
    var name = base;
    var hIndex = name.indexOf('#');
    var hash = hIndex >= 0 ? name.substring(hIndex) : '';
    if (hIndex >= 0) {
        name = name.substring(0, hIndex);
    }
    var qIndex = name.indexOf('?');
    var search = qIndex >= 0 ? name.substring(qIndex) : '';
    if (qIndex >= 0) {
        name = name.substring(0, qIndex);
    }
    var dotIndex = name.lastIndexOf('.');
    var ext = dotIndex >= 0 ? name.substring(dotIndex) : '';
    if (dotIndex >= 0) {
        name = name.substring(0, dotIndex);
    }
    return {
        ext: ext,
        hash: hash,
        name: name,
        path: pathname,
        search: search,
    };
};
//# sourceMappingURL=parseFileUrl.js.map