"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UpdateRunner = void 0;
const DeferredPromise_1 = require("./promise/DeferredPromise");
class UpdateRunner {
    constructor(job) {
        this.job = job;
        this._running = false;
        this._queued = false;
        this._promise = null;
    }
    queue() {
        if (this._running) {
            this._queued = true;
        }
        else {
            this.run();
        }
    }
    queued() {
        return this._queued;
    }
    running() {
        return this._running;
    }
    async wait() {
        if (this._running) {
            if (!this._promise) {
                this._promise = new DeferredPromise_1.DeferredPromise();
            }
            return this._promise.promise;
        }
    }
    async run() {
        this._queued = false;
        this._running = true;
        await this.job();
        this._running = false;
        if (this._queued) {
            this.run();
        }
        else if (this._promise) {
            this._promise.resolve();
            this._promise = null;
        }
    }
}
exports.UpdateRunner = UpdateRunner;
//# sourceMappingURL=UpdateRunner.js.map