"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoize = void 0;
exports.memoize = (fn) => {
    let prevArgs = null;
    let prevReturn = null;
    return function memoizedFn(...args) {
        let changed = false;
        if (prevArgs) {
            const len = args.length;
            for (let i = 0; i < len; i += 1) {
                if (args[i] !== prevArgs[i]) {
                    changed = true;
                    break;
                }
            }
        }
        else {
            changed = true;
        }
        if (changed) {
            prevArgs = args;
            prevReturn = fn.apply(this, args);
            return prevReturn;
        }
        return prevReturn;
    };
};
//# sourceMappingURL=memoize.js.map