"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoizeCompose = void 0;
const memoize_1 = require("./memoize");
const memoizeArg_1 = require("./memoizeArg");
exports.memoizeCompose = (argFns, fn) => {
    const len = argFns.length;
    if (len > 1) {
        const memoized1 = memoize_1.memoize(fn);
        return function memoizedFn(...args) {
            const prevArgs = [];
            for (let i = 0; i < len; i += 1) {
                prevArgs.push(argFns[i].apply(this, args));
            }
            return memoized1.apply(this, prevArgs);
        };
    }
    const [argFn] = argFns;
    const memoized2 = memoizeArg_1.memoizeArg(fn);
    return function memoizedFn(arg) {
        return memoized2.call(this, argFn(arg));
    };
};
//# sourceMappingURL=memoizeCompose.js.map