"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepMapObjectWithoutEmpty = exports.deepMapArrayWithoutEmpty = void 0;
const is_1 = require("../is");
const getKeys_1 = require("../object/getKeys");
exports.deepMapArrayWithoutEmpty = (arr, fn) => {
    const copy = [];
    const len = arr.length;
    for (let i = 0; i < len; i += 1) {
        const value = arr[i];
        let newValue;
        if (is_1.isObject(value)) {
            if (Array.isArray(value)) {
                newValue = exports.deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = exports.deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, i, arr);
        }
        if (newValue != null && newValue === newValue) {
            copy.push(newValue);
        }
    }
    return copy.length ? copy : null;
};
exports.deepMapObjectWithoutEmpty = (obj, fn) => {
    const copy = {};
    const keys = getKeys_1.getKeys(obj);
    const len = keys.length;
    let nonEmpty = false;
    for (let i = 0; i < len; i += 1) {
        const key = keys[i];
        const value = obj[key];
        let newValue;
        if (is_1.isObject(value)) {
            if (Array.isArray(value)) {
                newValue = exports.deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = exports.deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, key, obj);
        }
        if (newValue != null && newValue === newValue) {
            nonEmpty = true;
            copy[key] = newValue;
        }
    }
    return nonEmpty ? copy : null;
};
//# sourceMappingURL=deepMap.js.map