"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapStruct = void 0;
const getKeys_1 = require("../object/getKeys");
exports.mapStruct = (obj, fnMap) => {
    const copy = {};
    const keys = getKeys_1.getKeys(obj);
    const len = keys.length;
    let nonEmpty = false;
    for (let i = 0; i < len; i += 1) {
        const key = keys[i];
        const fn = fnMap[key];
        if (fn) {
            const value = fn(obj[key], key, obj);
            if (value !== undefined && value === value) {
                nonEmpty = true;
                copy[key] = value;
            }
        }
    }
    return nonEmpty ? copy : undefined;
};
//# sourceMappingURL=mapStruct.js.map