"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.copy = void 0;
const getKeys_1 = require("./getKeys");
const hasOwnProp_1 = require("./hasOwnProp");
exports.copy = (to, from, keys, own = true) => {
    const out = to;
    if (keys) {
        const len = keys.length;
        if (own) {
            if (from.hasOwnProperty) {
                for (let i = 0; i < len; i += 1) {
                    const key = keys[i];
                    if (from.hasOwnProperty(key)) {
                        out[key] = from[key];
                    }
                }
            }
            else {
                for (let i = 0; i < len; i += 1) {
                    const key = keys[i];
                    if (hasOwnProp_1.hasOwnProperty.call(from, key)) {
                        out[key] = from[key];
                    }
                }
            }
        }
        else {
            for (let i = 0; i < len; i += 1) {
                const key = keys[i];
                if (key in from) {
                    out[key] = from[key];
                }
            }
        }
    }
    else {
        const fkeys = getKeys_1.getKeys(from);
        const len = fkeys.length;
        for (let i = 0; i < len; i += 1) {
            const key = fkeys[i];
            out[key] = from[key];
        }
    }
    return out;
};
//# sourceMappingURL=copy.js.map