"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepSortedCopy = void 0;
const getKeys_1 = require("./getKeys");
exports.deepSortedCopy = (obj) => {
    if (obj == null || typeof obj !== 'object') {
        return obj;
    }
    if (Array.isArray(obj)) {
        return obj.map(exports.deepSortedCopy);
    }
    const { constructor } = obj;
    if (constructor != null && constructor !== Object) {
        return obj;
    }
    let keys = getKeys_1.getKeys(obj);
    const len = keys.length;
    const dest = {};
    if (len) {
        keys = keys.sort();
        for (let i = 0; i < len; i += 1) {
            const key = keys[i];
            dest[key] = exports.deepSortedCopy(obj[key]);
        }
    }
    return dest;
};
//# sourceMappingURL=deepSortedCopy.js.map