"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mapKeys = void 0;
const getKeys_1 = require("./getKeys");
const hasOwnProp_1 = require("./hasOwnProp");
exports.mapKeys = (obj, keyMappings, dest = {}, own = true) => {
    const out = dest;
    const keys = getKeys_1.getKeys(keyMappings);
    const len = keys.length;
    if (own) {
        if (obj.hasOwnProperty) {
            for (let i = 0; i < len; i += 1) {
                const key = keys[i];
                if (obj.hasOwnProperty(key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
        else {
            for (let i = 0; i < len; i += 1) {
                const key = keys[i];
                if (hasOwnProp_1.hasOwnProperty.call(obj, key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
    }
    else {
        for (let i = 0; i < len; i += 1) {
            const key = keys[i];
            if (key in obj) {
                out[keyMappings[key]] = obj[key];
            }
        }
    }
    return out;
};
//# sourceMappingURL=mapKeys.js.map