"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toResult = void 0;
const dataToResult = (data) => ({
    data,
    error: null,
    resolved: true,
});
const errorToResult = (error) => ({
    data: null,
    error,
    resolved: false,
});
exports.toResult = (x) => {
    if (x != null) {
        if (typeof x.then === 'function') {
            return x.then(dataToResult, errorToResult);
        }
        if (x instanceof Error) {
            return errorToResult(x);
        }
    }
    return dataToResult(x);
};
//# sourceMappingURL=toResult.js.map