"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.inheritProps = void 0;
const hasOwnProp_1 = require("../object/hasOwnProp");
const inheritProp_1 = require("./inheritProp");
exports.inheritProps = (to, from, excludeKeys) => {
    const fromKeys = Object.getOwnPropertyNames(from);
    const len = fromKeys.length;
    if (excludeKeys) {
        for (let i = 0; i < len; i += 1) {
            const key = fromKeys[i];
            if (excludeKeys[key] !== 1 && !hasOwnProp_1.hasOwnProp(to, key)) {
                inheritProp_1.inheritProp(to, from, key);
            }
        }
    }
    else {
        for (let i = 0; i < len; i += 1) {
            const key = fromKeys[i];
            if (!hasOwnProp_1.hasOwnProp(to, key)) {
                inheritProp_1.inheritProp(to, from, key);
            }
        }
    }
    return to;
};
//# sourceMappingURL=inheritProps.js.map