"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.base64FromUrlSafe = void 0;
const safeChars = /[-_]/g;
const DEC = {
    '-': '+',
    _: '/',
};
const replaceSafeChar = (c) => DEC[c];
exports.base64FromUrlSafe = (safe) => {
    let base64 = safe.replace(safeChars, replaceSafeChar);
    const len = base64.length % 4;
    if (len === 2) {
        base64 += '==';
    }
    else if (len === 3) {
        base64 += '=';
    }
    return base64;
};
//# sourceMappingURL=base64FromUrlSafe.js.map