export declare class Timestamp {
    milliseconds: number;
    nanoseconds: number;
    static getMilliseconds: () => number;
    static getNanoseconds: () => number;
    static nanosecondsCalibration: number;
    static calibrate: (accuracy?: number) => number;
    static currentNanoseconds: () => number;
    static now: () => Timestamp;
    static from: (ms: number | string | Date, ns?: number) => Timestamp | null;
    static parseNanoseconds: (str: string) => Timestamp | null;
    static parseMilliseconds: (str: string) => Timestamp | null;
    constructor(milliseconds: number, nanoseconds: number);
    toDate(): Date;
    toMilliseconds(): number;
    toMillisecondsString(): string;
    toNanosecondsString(): string;
    toString(): string;
    toISOString(): string;
    addSeconds(seconds: number): Timestamp;
    addMinutes(minutes: number): Timestamp;
    addHours(hours: number): Timestamp;
    addDays(days: number): Timestamp;
    clone(): Timestamp;
    equal(ts: Timestamp): boolean;
}
//# sourceMappingURL=Timestamp.d.ts.map