import { DeferredPromise } from './promise/DeferredPromise';
export class UpdateRunner {
    constructor(job) {
        this.job = job;
        this._running = false;
        this._queued = false;
        this._promise = null;
    }
    queue() {
        if (this._running) {
            this._queued = true;
        }
        else {
            this.run();
        }
    }
    queued() {
        return this._queued;
    }
    running() {
        return this._running;
    }
    async wait() {
        if (this._running) {
            if (!this._promise) {
                this._promise = new DeferredPromise();
            }
            return this._promise.promise;
        }
    }
    async run() {
        this._queued = false;
        this._running = true;
        await this.job();
        this._running = false;
        if (this._queued) {
            this.run();
        }
        else if (this._promise) {
            this._promise.resolve();
            this._promise = null;
        }
    }
}
//# sourceMappingURL=UpdateRunner.js.map