export declare type ValueListener<T> = (value: T, prevValue: T) => void;
export declare type Updater<T> = (v: T) => T;
export interface IListenerOptions {
    async?: boolean;
}
export declare type ValueOffFunction = () => void;
export declare class Value<T> {
    protected _value: T;
    private fns;
    private asyncFns;
    private asyncQueued;
    constructor(_value: T);
    on(fn: ValueListener<T>, opts?: IListenerOptions): ValueOffFunction;
    off(fn: ValueListener<T>, opts?: IListenerOptions): void;
    once(fn: ValueListener<T>, opts?: IListenerOptions): ValueOffFunction;
    get value(): T;
    get(): T;
    set(value: T | Updater<T>): void;
    clear(): void;
}
//# sourceMappingURL=Value.d.ts.map