export const unique = (list, toKey) => {
    if (!list.length) {
        return [];
    }
    const exists = {};
    switch (typeof toKey) {
        case 'function':
            return list.filter((x, i) => {
                const k = toKey(x, i, list);
                if (k == null || exists[k] === 1) {
                    return false;
                }
                exists[k] = 1;
                return true;
            });
        case 'string':
            return list.filter((x) => {
                const k = x[toKey];
                if (k == null || exists[k] === 1) {
                    return false;
                }
                exists[k] = 1;
                return true;
            });
        default:
            return list.filter((x) => {
                const k = String(x);
                if (exists[k] === 1) {
                    return false;
                }
                exists[k] = 1;
                return true;
            });
    }
};
//# sourceMappingURL=unique.js.map