export const uniqueWithIndexes = (list, toKey) => {
    const len = list.length;
    const indexes = [];
    if (!len) {
        return { list: [], indexes };
    }
    const keyToIndex = {};
    let ulist;
    let index = 0;
    switch (typeof toKey) {
        case 'function':
            ulist = list.filter((x, i) => {
                const k = toKey(x, i, list);
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
        case 'string':
            ulist = list.filter((x, i) => {
                const k = x[toKey];
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
        default:
            ulist = list.filter((x, i) => {
                const k = String(x);
                if (typeof keyToIndex[k] === 'number') {
                    indexes[i] = keyToIndex[k];
                    return false;
                }
                indexes[i] = keyToIndex[k] = index;
                index += 1;
                return true;
            });
            break;
    }
    return { list: ulist, indexes };
};
//# sourceMappingURL=uniqueWithIndexes.js.map