export const memoizeArg = (fn) => {
    let called = false;
    let prevArg;
    let prevReturn;
    return function memoizedFn(arg) {
        if (called && arg === prevArg) {
            return prevReturn;
        }
        called = true;
        prevArg = arg;
        prevReturn = fn.call(this, arg);
        return prevReturn;
    };
};
//# sourceMappingURL=memoizeArg.js.map