import { isObject } from '../is';
import { getKeys } from '../object/getKeys';
export const deepMapArrayWithoutEmpty = (arr, fn) => {
    const copy = [];
    const len = arr.length;
    for (let i = 0; i < len; i += 1) {
        const value = arr[i];
        let newValue;
        if (isObject(value)) {
            if (Array.isArray(value)) {
                newValue = deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, i, arr);
        }
        if (newValue != null && newValue === newValue) {
            copy.push(newValue);
        }
    }
    return copy.length ? copy : null;
};
export const deepMapObjectWithoutEmpty = (obj, fn) => {
    const copy = {};
    const keys = getKeys(obj);
    const len = keys.length;
    let nonEmpty = false;
    for (let i = 0; i < len; i += 1) {
        const key = keys[i];
        const value = obj[key];
        let newValue;
        if (isObject(value)) {
            if (Array.isArray(value)) {
                newValue = deepMapArrayWithoutEmpty(value, fn);
            }
            else {
                newValue = deepMapObjectWithoutEmpty(value, fn);
            }
        }
        else {
            newValue = fn(value, key, obj);
        }
        if (newValue != null && newValue === newValue) {
            nonEmpty = true;
            copy[key] = newValue;
        }
    }
    return nonEmpty ? copy : null;
};
//# sourceMappingURL=deepMap.js.map