import { getKeys } from '../object/getKeys';
export const mapStructPartial = (obj, fnMap) => {
    const copy = {};
    const keys = getKeys(fnMap);
    const len = keys.length;
    let nonEmpty = false;
    for (let i = 0; i < len; i += 1) {
        const key = keys[i];
        const value = fnMap[key](obj[key], key, obj);
        if (value !== undefined && value === value) {
            nonEmpty = true;
            copy[key] = value;
        }
    }
    return nonEmpty ? copy : undefined;
};
//# sourceMappingURL=mapStructPartial.js.map