import { getKeys } from './getKeys';
export const deepSortedCopy = (obj) => {
    if (obj == null || typeof obj !== 'object') {
        return obj;
    }
    if (Array.isArray(obj)) {
        return obj.map(deepSortedCopy);
    }
    const { constructor } = obj;
    if (constructor != null && constructor !== Object) {
        return obj;
    }
    let keys = getKeys(obj);
    const len = keys.length;
    const dest = {};
    if (len) {
        keys = keys.sort();
        for (let i = 0; i < len; i += 1) {
            const key = keys[i];
            dest[key] = deepSortedCopy(obj[key]);
        }
    }
    return dest;
};
//# sourceMappingURL=deepSortedCopy.js.map