const defaultPropDesc = {
    writable: true,
    enumerable: true,
    configurable: true,
};
export const defineLazyProp = (obj, key, getter, { writable = true, enumerable = true, configurable = true, } = defaultPropDesc) => Object.defineProperty(obj, key, {
    get() {
        const value = getter.call(this);
        Object.defineProperty(this, key, {
            value,
            writable,
            enumerable,
            configurable,
        });
        return value;
    },
    enumerable,
    configurable: true,
});
//# sourceMappingURL=defineLazyProp.js.map