import { getter } from './getter';
export const immutableSetter = (path, cloneObject) => {
    const keys = path.split('.');
    const lastIndex = keys.length - 1;
    const getValue = getter(path);
    if (cloneObject) {
        return (obj, value) => {
            if (getValue(obj) === value) {
                return obj;
            }
            const newObj = Object.assign({}, obj);
            let scope = newObj;
            let i = 0;
            const curPath = [];
            for (; i < lastIndex; i += 1) {
                const key = keys[i];
                curPath.push(key);
                scope = scope[key] = cloneObject(scope[key], key, curPath, scope);
            }
            scope[keys[i]] = value;
            return newObj;
        };
    }
    return (obj, value) => {
        if (getValue(obj) === value) {
            return obj;
        }
        const newObj = Object.assign({}, obj);
        let scope = newObj;
        let i = 0;
        for (; i < lastIndex; i += 1) {
            const key = keys[i];
            scope = scope[key] = Object.assign({}, scope[key]);
        }
        scope[keys[i]] = value;
        return newObj;
    };
};
//# sourceMappingURL=immutableSetter.js.map