import { getKeys } from './getKeys';
import { hasOwnProperty } from './hasOwnProp';
export const mapKeys = (obj, keyMappings, dest = {}, own = true) => {
    const out = dest;
    const keys = getKeys(keyMappings);
    const len = keys.length;
    if (own) {
        if (obj.hasOwnProperty) {
            for (let i = 0; i < len; i += 1) {
                const key = keys[i];
                if (obj.hasOwnProperty(key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
        else {
            for (let i = 0; i < len; i += 1) {
                const key = keys[i];
                if (hasOwnProperty.call(obj, key)) {
                    out[keyMappings[key]] = obj[key];
                }
            }
        }
    }
    else {
        for (let i = 0; i < len; i += 1) {
            const key = keys[i];
            if (key in obj) {
                out[keyMappings[key]] = obj[key];
            }
        }
    }
    return out;
};
//# sourceMappingURL=mapKeys.js.map