export const setter = (path, createObject) => {
    const keys = path.split('.');
    const lastIndex = keys.length - 1;
    if (createObject) {
        return (obj, value) => {
            let scope = obj;
            let i = 0;
            const curPath = [];
            for (; i < lastIndex; i += 1) {
                const key = keys[i];
                curPath.push(key);
                scope = scope[key] || (scope[key] = createObject(key, curPath, scope));
            }
            scope[keys[i]] = value;
            return obj;
        };
    }
    return (obj, value) => {
        let scope = obj;
        let i = 0;
        for (; i < lastIndex; i += 1) {
            const key = keys[i];
            scope = scope[key] || (scope[key] = {});
        }
        scope[keys[i]] = value;
        return obj;
    };
};
//# sourceMappingURL=setter.js.map