export declare class TimeoutError extends Error {
}
export declare class DeferredPromise<T, E = any> {
    protected timeout?: number | undefined;
    protected readonly _promise: Promise<T>;
    protected _resolve: ((value: T | PromiseLike<T>) => void) | null;
    protected _reject: ((reason?: E | TimeoutError) => void) | null;
    protected _tid?: any;
    protected _fulfilled: boolean;
    constructor(timeout?: number | undefined);
    resolve(value: T | PromiseLike<T>): void;
    reject(reason: E | TimeoutError): void;
    then<T1 = T, T2 = never>(onFulfilled?: ((value: T) => T1 | PromiseLike<T1>) | undefined | null, onRejected?: ((reason: any) => T2 | PromiseLike<T2>) | undefined | null): Promise<T1 | T2>;
    catch<T1 = never>(onRejected?: ((reason: any) => T1 | PromiseLike<T1>) | undefined | null): Promise<T | T1>;
    finally(onFinally: () => void): Promise<T>;
    private clear;
    get promise(): Promise<T>;
    get pending(): boolean;
    get fulfilled(): boolean;
    get rejected(): boolean;
    get status(): 'pending' | 'fulfilled' | 'rejected';
}
//# sourceMappingURL=DeferredPromise.d.ts.map