export const withTimeout = (promise, timeout) => new Promise((resolve, reject) => {
    setTimeout(() => reject(new Error('timeout')), timeout);
    try {
        if (typeof promise === 'function') {
            promise().then(resolve, reject);
        }
        else {
            promise.then(resolve, reject);
        }
    }
    catch (e) {
        reject(e);
    }
});
//# sourceMappingURL=withTimeout.js.map