import { hasOwnProp } from '../object/hasOwnProp';
import { inheritProp } from './inheritProp';
export const inheritProps = (to, from, excludeKeys) => {
    const fromKeys = Object.getOwnPropertyNames(from);
    const len = fromKeys.length;
    if (excludeKeys) {
        for (let i = 0; i < len; i += 1) {
            const key = fromKeys[i];
            if (excludeKeys[key] !== 1 && !hasOwnProp(to, key)) {
                inheritProp(to, from, key);
            }
        }
    }
    else {
        for (let i = 0; i < len; i += 1) {
            const key = fromKeys[i];
            if (!hasOwnProp(to, key)) {
                inheritProp(to, from, key);
            }
        }
    }
    return to;
};
//# sourceMappingURL=inheritProps.js.map