import { AnyFunction, AnyObjectWithStringKeys, NonNil, NonUndefined } from 'tsdef';
export declare type PropKey = string | number | symbol;
export declare type AnyObject = AnyObjectWithStringKeys;
export declare type ReturnTypeOrNever<T> = T extends AnyFunction ? ReturnType<T> : never;
export declare type Exact<T, X extends T> = T & {
    [K in keyof X]: K extends keyof T ? X[K] : never;
};
export declare type KeyOfTypeReverse<T, U> = {
    [P in keyof T]-?: U extends T[P] ? P : never;
}[keyof T];
export declare type WithoutUndefined<T> = Pick<T, Exclude<keyof T, KeyOfTypeReverse<T, undefined>>> & {
    [P in KeyOfTypeReverse<T, undefined>]?: NonUndefined<T[P]>;
};
export declare type WithoutNil<T> = Pick<T, Exclude<keyof T, KeyOfTypeReverse<T, undefined | null>>> & {
    [P in KeyOfTypeReverse<T, undefined | null>]?: NonNil<T[P]>;
};
export declare type toKeyFn<T> = (item: T, i: number, list: T[]) => string | number;
//# sourceMappingURL=ts.d.ts.map